﻿Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Syncfusion.Windows.Forms.Diagram

Namespace _116081
	Partial Public Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
		End Sub

		Private Sub Form1_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
			diagram1.Controller.InPlaceEditing = False

			Dim palette As New SymbolPalette("Nodes")
			Dim ellp As New Ellipse(100, 100, 60, 60)
			ellp.Name = "Pump"
			ellp.Tag = "Pump"
			palette.AppendChild(ellp)
			Dim rect As New Syncfusion.Windows.Forms.Diagram.Rectangle(100, 100, 60, 60)
			rect.Name = "Box"
			rect.Tag = "Box"
			palette.AppendChild(rect)
			paletteGroupBar1.AddPalette(palette)

			AddHandler diagram1.Model.EventSink.NodeCollectionChanged, AddressOf EventSink_NodeCollectionChanged
			AddHandler diagram1.EventSink.NodeDoubleClick, AddressOf EventSink_NodeDoubleClick
		End Sub

		Private Sub EventSink_NodeDoubleClick(ByVal evtArgs As NodeMouseEventArgs)
			Dim node As Node = TryCast(evtArgs.Node, Node)
			If Not node.PropertyBag.ContainsKey("OldName") Then
				node.PropertyBag.Add("OldName", node.Name)
			End If
			node.Name = "PumpDoubleClicked"
			If Not node.PropertyBag.ContainsKey("NewName") Then
				node.PropertyBag.Add("NewName", node.Name)
			End If
		End Sub

		Private Sub EventSink_NodeCollectionChanged(ByVal evtArgs As CollectionExEventArgs)
			Dim i As Integer = 0, j As Integer = 0
			For Each node As Node In diagram1.Model.Nodes
				Select Case node.Tag.ToString()
					Case "Pump"
						i += 1
					Case "Box"
						j += 1
				End Select
			Next node
			MessageBox.Show("Number of Pump Nodes:" & i.ToString() & Constants.vbLf & "Number of Box Nodes:" & j.ToString())
		End Sub

	End Class
End Namespace
